var scaled=false;
var printing=false;
var canvasing=false;
var palette=false;
var slinkiShowSplashDuration=3000;
var bespoke=null;
var tempScaleStyle=null;

//alert("Welcome to Bespoke")

function boot(){
	if(slinki.error)
	{	alert("Problem parsing {slinkiBespoke} JSON\n"+slinki.json);
	}
	setTitle();
	setCopyright();
	setFavicon();
	setScripts();
	setCSS();
	
	//To work round browser bug find articles that have gone into the DOM and been unwrapped from their <slide> parent
	$("slide").filter(function(){
		return $(this).find("article").size()==0;	//Find slides with no <article> inside
	}).each(function(){
		var s=$(this)
		var a=s.parent().next("article");	//Step up to parent (for some reason browser puts them in a <p> block) then find the lost <article>.
		if(a!=null)
		{	s.append(a.detach());	//Put it back where it came from!
		}
		else
		{	//We can't find the article so delete the empty slide ;-(
			s.detach();
		}
	})
	;
	//In case we missed any look for unwrapped <article> and wrap then in <slide>
	$("article").filter(function(){
		var p=$(this).parent()[0];
		return p.nodeName!="SLIDE";
	}).wrap("<slide> </slide>")
		
	//Now take care of all well structured slides
	var slides=$("slide").detach();
	//alert(slides[0])
	$("body").children().remove();
		
	//Put the slides back
	$("body").append("<div class='bespoke-theme-cube-slide-parent'><slides class='slides' id='insertSlides'> </slides></div><div id='bespokeBoot'> </div>");
	slides.appendTo("#insertSlides");
	
	bootBespoke();
	
	setVertical();

	//Bind events
	bindKeys();
	$("slide").each(
		function() {
			$(this).attr("index", $(this).index());
		}).click(onSlideClick);
	$(".slides").dblclick(function(){ scaleOn();});
	
	//Add canvas
	$("body").append('<canvas id="canvas" style="display: none; pointer-events: all; z-index:999; position:absolute;top:0;left:0;"></canvas>');
	initCanvas();
	$(window).resize(initCanvas);
	canvasOff();
	
	//Mouse Events
	$(document).ready(function(){ 
		  document.oncontextmenu = function() {return false;};
		  $(document).mousedown(onMouseDown);
		}
	);

}
function bootBespoke()
{	//Boot Bespoke
	$("#bespokeBoot").append("<script data-main='/wink/res/bespoke/2016-01-07/js/innerBoot' src='/wink/res/winkutil/require-2.1.22.min.js'>_</script>");
}

function onMouseDown(evt)
{	//Right click action
	if( evt.button == 2 ) { 
		if(canvasing)
		{	//alert("Show Canvas Context Menu");
			canvasShowPalette(evt);
			return true;
		}
		else
		{	if(!scaled && !printing){
				scaleOn();
				return true;
			}
		}
	}
	//Left click on edge action - page turn
	if( evt.button == 0 ) { 
		if(!canvasing && !scaled && !printing)
		{	if(evt.target.nodeName=="SLIDES")
			{	mx = evt.clientX;	
				if(mx > window.innerWidth /2)
				{	gDeck.slide(gDeck.slide()+1);
				}
				else
				{	gDeck.slide(gDeck.slide()-1);
					
				}
			}
			return true;
		}
	}
	return false; 
}
function onSlideClick(slide)
{	if(scaled)
	{	scaleOff();
	}
	if(printing)
	{	printOff();
	}
	gDeck.slide(parseInt($(this).attr("index")));
}
function showSplash()
{	if(slinki.splashDuration!=null)
	{	slinkiShowSplashDuration=slinki.splashDuration;
	}
	show=$("#splash").length==1;
	if(show && slinkiShowSplashDuration>0)
	{
	 	$("#splash").css({"opacity" : 1, "display": "block", "visibility" : "visible" , "position":"fixed", "top": "25%" , "left": "25%", "width": "50%", "height":"50%" , "z-index":"1000"} ); 
	 	$("#splash").click(function()
	 		{	hideSplash(0);
	 			return false;
	 		}	
	 	);
	 	setTimeout('hideSplash(500)', slinkiShowSplashDuration);
 	}
}
 
function hideSplash(t)
{	$("#splash").fadeOut(t);
	//$("slide").css({ "opacity" : 1.0 } );
	//remove splash so it doesn't appear in printout
	$("#splash").remove();
}
 
function setVertical()
{	h=$(window).height();
	h=h*0.65;
	$(".vframe").css({"height":h});
}

function bindKeys()
{	$("body").keydown(function(evt){
			//O-Key - Scaled Overview
			if(!printing && evt.which==79)
			{	if(!scaled)
				{	scaleOn();
				}
				else
				{	scaleOff();	
				}
			}
			//P-Key - Print Overview
			if(!scaled && !evt.ctrlKey && evt.which==80)
			{	if(!printing)
				{	printOn();
				}
				else
				{	printOff();	
				}
			}
			//E-Key - Erase Canvas
			if(canvasing && !evt.ctrlKey && evt.which==69)
			{	canvasErase();
			}
			//C-Key - Toggle Canvas
			if(!evt.ctrlKey && evt.which==67)
			{	canvasToggle();
			}
		}
	);
}
function printOn()
{	hideBespoke();
	canvasOff();
	tempScaleStyle=$(".ekopseb-scale-parent").attr("style");  //Need to preserve this
	$(".ekopseb-scale-parent").attr("style", "");   //Remove any dynamic scaling
	$("body").attr("style", "background-color: white;");
	//Hide originals, add clean viewing container and clone slides there
	$("slides").hide();
	slides=$("slide");
	console.log("Slides length="+slides.length);
	var page=0;
	var pages=[];
	$("slide").clone(true).each(function(){
		$(this).removeClass().addClass("slinki-print");
		idx=parseInt($(this).attr("index"));
		if(idx % 2 == 0)
		{	$("body").append("<div page='"+page+"' class='slinki-page-break'></div>");
			page++;
		}
		pages.push($(this));
	})
	for(i=0; i<pages.length; i=i+2)
	{	r=$(".slinki-page-break[page="+i/2+"]");
		r.append(pages[i]);
		r.append(pages[i+1]);		
	}
	printing=true;
}
function printOff()
{	//Remove viewing container and restore originals
	if(canvasing)
	{	canvasOn();		
	}
	$("body").attr("style", "");
	$(".slinki-page-break").detach();
	
	$("slides").show();
	$(".ekopseb-scale-parent").attr("style", tempScaleStyle);  //This is important else slides revert back to fixed size when fullscreen
	restoreBespoke();
	printing=false;
}
function scaleOn()
{	hideBespoke();
	canvasOff();
	tempScaleStyle=$(".ekopseb-scale-parent").attr("style");  //Need to preserve this
	$(".ekopseb-scale-parent").attr("style", "");   //Remove any dynamic scaling
	
	//Create the scale UI
	$("body").append("<div id='slinkiScaleView' class='slinki-scaled-slides'></div>");
	$("body").append("<div class='nklogo' style='padding: 8px 10px 15px 10px; background-color: #888; border-radius: 3px; float:left; margin-left: 70px; margin-top: 60px;'><a href='http://1060research.com'><img src='http://www.1060research.com/netkernel/poweredbynetkernel.png' alt='Powered by Netkernel'/></a></div>");
	$("body").append("<div class='nklogo' style='float:left; color: #444; font-family: Arial; font-size: 35px; transform: translateX(-400px) translateY(320px) rotate(90deg); padding:50px;'><span style='color: #666;'>NetKernel</span> Uniform Resource Engine<br/>Resource Oriented Computing<sup>TM</sup><br/>1060 Research <span style='color: #222;'>ROC</span></div>");
	//Controls
	temp="<div class='nklogo' style='float: right; padding: 10px;'>";
	temp+="<div style='display: block; margin: 20px; color: #999;' id='printPreview' onclick='scaleOff();printOn();window.print();'><i class='fa fa-print'> </i></div>";
	temp+="<div class='nklogo' id='canvasOverlay' style='display: block; margin: 20px; padding: 3px; background-color: #999;' onclick='scaleOff();canvasToggle();'><i class='fa fa-paint-brush'> </i></div>";
	temp+="</div>";
	$("body").append(temp);
	
	//Hide originals, add clean viewing container and clone slides there
	$("slides").hide();
	slides=$("slide");
	console.log("Slides length="+slides.length);
	$("slide").clone(true).removeClass().addClass("slinki-scaled").appendTo("#slinkiScaleView");
	scaled=true;
	if(canvasing)
	{	$("#canvasOverlay").css("color", x);
	}
}
function scaleOff()
{	//Remove viewing container and restore originals
	if(canvasing)
	{	canvasOn();		
	}
	$("#slinkiScaleView").detach();
	$(".nklogo").detach();
	$("#printPreview").detach();
	$("slides").show();
	$(".ekopseb-scale-parent").attr("style", tempScaleStyle);  //This is important else slides revert back to fixed size when fullscreen
	//Restore bespoke classes with rename
	restoreBespoke();
	scaled=false;
}
function hideBespoke(){
	//Hide all bespoke classes by renaming them
	$('[class^="bespoke"]').each( function(){
		cls=$(this).attr("class").split("bespoke").join("ekopseb"); //Fast rename trick
		$(this).attr("class", cls);
	});
}
function restoreBespoke(){
	//Restore bespoke classes with rename
	$('[class^="ekopseb"]').each( function(){
		cls=$(this).attr("class").split("ekopseb").join("bespoke");
		$(this).attr("class", cls);
	});
}

//SliNKi Initialisation
function setTitle()
{	title=slinki.title;
	try
	{	if(title==null)
		{	header=$("h1:first");
			if(header==null)
			{	header=$("h2:first");
			}
			if(header==null)
			{	header=$("h3:first");
			}
			if(header==null)
			{	header=$("p:first");
			}
			title="SliNKi : "+header.text();
		}
	}
	catch(e)
	{	title="SliNKi Presentation";
	}
	$("title").html(title);
}
function setCopyright()
{	copyright=slinki.copyright;
	if(copyright!=null)
	{	$("head meta[name='copyright']").attr("content", copyright);
	}
}
function setFavicon()
{	favicon=slinki.favicon;
	if(favicon!=null)
	{	$("#favicon").attr("href", favicon);
	}
	//Force browsers to see that favicon has changed!
	favicon=$("#favicon").detach();
	$("head").append(favicon);
}
function setScripts()
{	if(slinki.scripts!=null)
	{	for(i=0; i<slinki.scripts.length; i++)
		{	s=slinki.scripts[i];
			$("head").append("<script src='"+s+"' type='text/javascript'>_</script>");
		}
	}
}
function setCSS()
{	var css=slinki.css;
	if(css==null)
	{	//Default CSS
		css= [
				{ "href" : "/wink/res/bespoke/2016-01-07/css/1060-theme.css", "media" : "all"},
				{ "href" : "/wink/res/wink/css/fontawesome/4.5.0/css/font-awesome.min.css" }
			];
	}
	else
	{	//Find fontawesome and if not present add it...
		var awesomeize=true;
		for(i=0; i<css.length; i++)
		{	s=css[i];
			if(s.href.indexOf("font-awesome") > -1)
			{	awesomeize=false;
				break;
			}
		}
		if(awesomeize)
		{	temp={ "href" : "/wink/res/wink/css/fontawesome/4.5.0/css/font-awesome.min.css" };
			css.unshift(temp);
		}
	}
	for(i=0; i<css.length; i++)
	{	s=css[i];
		href=s.href;
		media=s.media;
		if(media==null)
		{	set=true;
			if(s.screen)
			{	screencss=s.href;
			}
			if(s.pdf)
			{	pdfcss=s.href;
				set=false;
			}
			if(set)
			{	$("head").append("<link href='"+s.href+"' rel='stylesheet' type='text/css' />");
			}
		}
		else
		{	$("head").append("<link href='"+s.href+"' rel='stylesheet' type='text/css' media='"+media+"'/>");
		}
	}
}

//////////////CANVAS DRAWING///////////////////
var canvas, ctx, flag = false,
    prevX = 0,
    currX = 0,
    prevY = 0,
    currY = 0,
    dot_flag = false;

var x = "red",
    y = 2;

function initCanvas() {
	$("body").append('<div id="canvasIndicator" class="canvas" style="margin: 5px; visibility:hidden;z-index:999; position:absolute;top:0;left:0;width: 10px; height: 10px;"></div>');
	$("#canvas").attr("width", window.innerWidth).attr("height", window.innerHeight).show();
    canvas = document.getElementById("canvas");
    ctx = canvas.getContext("2d");
    w = canvas.width;
    h = canvas.height;
    canvas.addEventListener("mousemove", function (e) {
        findxy('move', e)
    }, false);
    canvas.addEventListener("mousedown", canvasOnMouseDown, false);
    canvas.addEventListener("mouseup", function (e) {
        findxy('up', e)
    }, false);
    canvas.addEventListener("mouseout", function (e) {
        findxy('out', e)
    }, false);
}
function canvasOnMouseDown(e)
{	if( e.button == 0 ) { 
		findxy('down', e); 
		return false;
	}
}
function canvasToggle()
{	if(canvasing)
	{	canvasOff();
	}
	else
	{	canvasOn();
	}
	canvasing=!canvasing;
}
function canvasOn()
{	$("#canvas").css("visibility", "visible");
	$("#canvasIndicator").css("visibility", "visible");
	canvasColor(x);
}
function canvasOff()
{	$("#canvas").css("visibility", "hidden");
	$("#canvasIndicator").css("visibility", "hidden");
}
function canvasShowPalette(evt)
{	if(!palette)
	{	palette=true;
		mx = evt.clientX - canvas.offsetLeft;
		my = evt.clientY - canvas.offsetTop;
		//canvas.removeEventListener("mousedown", canvasOnMouseDown);
		//alert(mx+":"+my);
		temp="<div class='palette' style='background-color: rgba(100,100,100,0.25); position: fixed; top: "+(my-20)+"px; left: "+mx+"px; padding: 10px; z-index: 9999; pointer-events: all;'>";
		var cols=["green", "red", "blue", "black", "yellow", "orange", "white"];
		for(var i in cols)
		{	var c=cols[i];
			temp+="<div id='"+c+"' class='colorselect' style='opacity: 1; display: inline-block; margin: 5px; pointer-events: all; width: 10px; height: 10px; background-color:"+c+";'>  </div>";
		}
		temp+="<div class='nklogo' style='display: inline; margin: 10px; color: #999;' onclick='canvasPaletteOff();canvasErase();'><i class='fa fa-eraser'> </i></div>";
		temp+="<div class='nklogo' id='canvasOverlay' style='display: inline; margin: 10px; padding: 3px; background-color: #999;' onclick='scaleOff();canvasToggle();'><i class='fa fa-paint-brush'> </i></div>";
		temp+="<div class='nklogo' style='display: inline; margin: 10px; color: #999;' onclick='canvasPaletteOff();scaleOn();'><i class='fa fa-star'> </i></div>";
		temp+="</div>";
		$(temp).insertBefore("#canvas");
		$("#canvasOverlay").css("color", x);
		$(".colorselect").click(
				function(){
					canvasColor($(this).attr("id"));
				}
			);
	}
}
function canvasColor(col) {
	x=col;
    if (x == "white") y = 14;
    else y = 2;
	$("#canvasIndicator").css("background-color", x);
	canvasPaletteOff();
}
function canvasPaletteOff()
{	palette=false;
	$(".palette").remove();
	//canvas.addEventListener("mousedown", canvasOnMouseDown, false);
}

function canvasDraw() {
    ctx.beginPath();
    ctx.moveTo(prevX, prevY);
    ctx.lineTo(currX, currY);
    ctx.strokeStyle = x;
    ctx.lineWidth = y;
    ctx.stroke();
    ctx.closePath();
}

function canvasErase() {
    ctx.clearRect(0, 0, w, h);
}

function findxy(res, e) {
    if (res == 'down') {
        prevX = currX;
        prevY = currY;
        currX = e.clientX - canvas.offsetLeft;
        currY = e.clientY - canvas.offsetTop;

        flag = true;
        dot_flag = true;
        if (dot_flag) {
            ctx.beginPath();
            ctx.fillStyle = x;
            ctx.fillRect(currX, currY, 2, 2);
            ctx.closePath();
            dot_flag = false;
        }
        canvasPaletteOff();
    }
    if (res == 'up' || res == "out") {
        flag = false;
    }
    if (res == 'move') {
        if (flag) {
            prevX = currX;
            prevY = currY;
            currX = e.clientX - canvas.offsetLeft;
            currY = e.clientY - canvas.offsetTop;
            canvasDraw();
        }
    }
    console.log(currX + ":"+ currY);
}
