//var bespoke = null;
var plugins=[];
var gDeck=null;

var classroom=false;
var classteacher= window.location.href.indexOf("localhost") > -1  && slinki.classroom;
var websocket=null;
var wsUri = "ws://"+document.location.host+"/slinki/websocket/wsClassRoomSync";
console.log(wsUri);

//Create a custom plugin
if(classteacher)
{
	var classPlugin = function() {
	  return function(deck) {
	    deck.on('activate', function(e) {
	      console.log('Activated slide ' + (e.index + 1) + ' of ' + deck.slides.length);
	      notifyClass(e.index);
	    });
	  }
	};
	
	plugins.push(classPlugin());
	console.log("Classroom Plugin Installed");
}

require(
		['bespoke.min',
		 'bespoke-classes.min',
		 'bespoke-keys.min',
		 'bespoke-scale.min',
		 'bespoke-progress.min',
		 'bespoke-backdrop.min',
		 'bespoke-bullets.min',
		 'bespoke-forms.min',
		 'bespoke-hash.min',
		 'bespoke-touch.min',
		 ]
		, function(){
			//We need to explicitly get bespoke as its not a plugin
			bespoke=arguments[0];

			//Deal with plugins
			for(i=1; i<arguments.length; i++)
			{	var initialized = arguments[i]();	//Remember to initialise plugin before its added to array
				plugins.push(initialized);
			}
			bespokeLoaded();
			}
		);

function bespokeLoaded()
{
	gDeck=bespoke.from(
			{ parent: '#insertSlides', slides: '#insertSlides > slide' } ,
			plugins
		);
	if(slinki.classroom)
	{	testWebSocket();
	}
}

function testWebSocket()
{
	try
	{	websocket = null;
		try
		{	websocket = new MozWebSocket(wsUri);
		}
		catch(e)
		{	try
			{	websocket = new WebSocket(wsUri);
			}
			catch(e2)
			{	websocket = new WebSocket(wsUri);
			}
		}
	    websocket.onopen = function(evt) { onOpen(evt) };
	    websocket.onclose = function(evt) { onClose(evt) };
	    websocket.onmessage = function(evt) { onMessage(evt) };
	    websocket.onerror = function(evt) { onError(evt) };
	}
	catch(e)
	{	console.log(e);
	}
}
function onOpen(evt)
{ console.log(evt);
}
function onClose(evt)
{ console.log(evt);
  testWebSocket();
}
function onMessage(evt)
{	if(!classteacher)
	{	console.log(evt);
		data=JSON.parse(evt.data);
		gDeck.slide(data.page);
	}
}
function onError(evt)
{ console.log(evt);
  throw(evt);
}
function notifyClass(p)
{	if(websocket!=null)
	{
		var m={ page: p};
	  	var message=JSON.stringify(m);
	  	websocket.send(message);
	}
}